---
name: Bug report
about: Create a report to help us improve
title: ''
labels: ''
assignees: ''

---

Please read before creating a new issue:

1. Make sure there is not already an open issue for this bug;
2. All enhancements must be off;
3. All advanced options MUST be at their default values;
4. Do not share save state files. Memory Cards are ok;
5. Verify your dump as we can not assist with issues resulting from bad dumps;
6. If playing PAL region software, please check whether or not the game has LibCrypt protection and that if it does, you have a correct SBI file (see https://github.com/stenzek/duckstation#libcrypt-protection-and-sbi-files for more information);
7. Please post your issue report in English as unfortunately this is the only language spoken by the developers. The Discord server has many helpful people if you need help translating.

Remove everything before and including this line before submitting.

**Game details**
[Serial Code, Region]
[i.e SLUS-00404 Ace Combat 2 (USA)]

**Description of the issue / bug**
[Describe what you are seeing and/or hearing during gameplay]

**Steps to reproduce**
[Try to provide as much detail as possible to reproduce the issue]

**Enhancements information**
[Make sure they are all turned off before report]

**Hardware/software**
[If Android, which phone and Android version]
[If desktop, your CPU, graphics card, and operating system]
[GPU Renderer - D3D11/OpenGL/Vulkan]

**Emulator version**
[Shown in the title bar of the emulator]

**Additional context**
[Add any other context about the problem here]
